﻿--- /home/cmeng/source/smack/Smack/tags/4.2.4/smack-core/src/main/java/org/jivesoftware/smack/util/PacketParserUtils.java	2018-04-15 20:01:49.000000000 
+++ /home/cmeng/workspace/android/smack/smack-core/src/main/java/org/jivesoftware/smack/util/PacketParserUtils.java	2018-05-25 14:16:12.000000000 
@@ -859,13 +859,20 @@
         final int initialDepth = parser.getDepth();
         Map<String, String> descriptiveTexts = null;
         List<ExtensionElement> extensions = new ArrayList<>();
         XMPPError.Builder builder = XMPPError.getBuilder();
 
         // Parse the error header
-        builder.setType(XMPPError.Type.fromString(parser.getAttributeValue("", "type")));
+        String errorType = parser.getAttributeValue("", "type");
+        if (StringUtils.isNullOrEmpty(errorType))
+            builder.setType(XMPPError.Type.CANCEL);
+        else
+            builder.setType(XMPPError.Type.fromString(errorType));
+        builder.setCondition(XMPPError.Condition.service_unavailable);
+
+        // builder.setType(XMPPError.Type.fromString(parser.getAttributeValue("", "type")));
         builder.setErrorGenerator(parser.getAttributeValue("", "by"));
 
         outerloop: while (true) {
             int eventType = parser.next();
             switch (eventType) {
             case XmlPullParser.START_TAG:
